/* $Id: KeyboardAppModel.h,v 1.8 2003/11/11 21:24:43 chrisf Exp $ */

/* Copyright (c) 2003 Chris Faherty */

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __KEYBOARDAPPMODEL_H__
#define __KEYBOARDAPPMODEL_H__

#include <c32comm.h>
#include "Keyboard.hrh"
#include "KeyboardAppView.h"

class RCommServ;
class RComm;
class CKeyboardAppView;

class CKeyboardAppModel : public CActive {
public:
    static CKeyboardAppModel *NewL();
    static CKeyboardAppModel *NewLC();

    RCommServ server;
    RComm commPort;
    TBool connected;
    TBuf8<16> localInputBuffer;

    CKeyboardAppModel();
    ~CKeyboardAppModel();
    void ConstructL();
    void Start();
    void Stop();
    void IssueRead();
    TBool Connected();

    /* CActive */
    void DoCancel();
    void RunL();

    CKeyboardAppView *iView;
    void SetView(CKeyboardAppView *aView);
};

#endif
