/* $Id: KeyboardAppView.h,v 1.16 2004/01/23 04:16:03 chrisf Exp $ */

/* Copyright (c) 2003 Chris Faherty */

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __KEYBOARDAPPVIEW_H__
#define __KEYBOARDAPPVIEW_H__

#include <coecntrl.h>
#include "KeyboardAppModel.h"
#include "KeyboardLayouts.h"

#define THINKOUTSIDE_MODEL 1
#define POCKETOP_MODEL 2
#define DEBUG_MODEL 3

#define US_LAYOUT 1
#define FR_LAYOUT 2
#define DE_LAYOUT 3

// forward declarations
class CEikRichTextEditor;
class CEikLabel;

class CKeyboardAppView : public CCoeControl {
public:
    CKeyboardAppModel *iModel;
    CEikLabel *iStatusWindow;
    CEikRichTextEditor *iOutputWindow;

    int keyboard_model;
    int keyboard_layout;

    CPeriodic *iTimer, *iForceBreakTimer;
    int tick;
    TBool shift, capslock, ctrl, alt, func, pt_shift, num_shift;
    int thinkoutside_state;
    TBool thinkoutside_isirdaframe;
    unsigned char lastraw;
    TInt lastscode;

    #define THINKOUTSIDE_MAX 0x5a
    kchar thinkoutside_plain[THINKOUTSIDE_MAX];
	kchar thinkoutside_shifted[THINKOUTSIDE_MAX];
	kchar thinkoutside_func[THINKOUTSIDE_MAX];
	kchar thinkoutside_func2[THINKOUTSIDE_MAX];

    static CKeyboardAppView *NewL(const TRect &aRect);
    static CKeyboardAppView *NewLC(const TRect &aRect);
    void SetModel(CKeyboardAppModel *aModel);
    ~CKeyboardAppView();

    void Draw(const TRect &aRect) const;
    TInt CountComponentControls() const;
    CCoeControl *ComponentControl(TInt aIndex) const;
    TKeyResponse OfferKeyEventL(const TKeyEvent &aKeyEvent,
        TEventCode aType);

    void ConstructL(const TRect &aRect);
    CKeyboardAppView();

    void Incoming(TDesC8 &buf);

    static TInt Tick(TAny *aObject);
    static TInt ForceBreakTick(TAny *aObject);

    void pocketop(unsigned char raw, TBool forcebreak);
    void thinkoutside(unsigned char raw, TBool forcebreak);
    void debug(unsigned char raw, TBool forcebreak);

    void initThinkoutsideLayout(const kchar * layout_plain,
        const kchar * layout_shifted,
        const kchar * layout_func,
        const kchar * layout_func2);
    void Init();
	int getKeyboardModel();
	int getKeyboardLayout();
	void setKeyboardModel(int model);
	void setKeyboardLayout(int layout);
};

#endif
