/* $Id: KeyboardLayouts.h,v 1.4 2004/01/23 04:16:03 chrisf Exp $ */

#ifndef __KEYBOARDLAYOUTS_H__
#define __KEYBOARDLAYOUTS_H__

#define KB_LEFT 1
#define KB_RIGHT 2
#define KB_UP 3
#define KB_DOWN 4
#define KB_LSHIFT 5
#define KB_RSHIFT 6
#define KB_FUNC 7
#define KB_BACKSPACE 8
#define KB_TAB 9
#define KB_COMMAND 11
#define KB_SHORTCUT 12
#define KB_ENTER 13
#define KB_CTL 14
#define KB_CAPLOCK 15
#define KB_MENU 16
#define KB_PGUP 17
#define KB_PGDN 18
#define KB_INSERT 19
#define KB_DATE 20
#define KB_ADDRESS 21
#define KB_TODO 22
#define KB_MEMO 23
#define KB_NUMLOCK 24
#define KB_ALT 25
#define KB_FUNC2 26
#define KB_ESC 27
#define KB_DELETE 127

typedef unsigned short kchar;

// ThinkOutside US Layout
const kchar layout_us_plain[] = {
	KB_TAB, 'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '-', '=', KB_BACKSPACE,
	KB_CAPLOCK, 'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', ';', '\'',  KB_ENTER,
	KB_LSHIFT,  'z', 'x', 'c', 'v', 'b', 'n', 'm', ',', '.', KB_UP, KB_RSHIFT,  '/',
	KB_CTL, KB_COMMAND,  KB_ALT,  KB_FUNC, ' ',       ' ', KB_FUNC2, KB_LEFT, KB_DOWN, KB_RIGHT,  KB_DELETE
};

const kchar layout_us_shifted[] = {
	KB_TAB, 'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', '_', '+', KB_BACKSPACE,
	KB_CAPLOCK, 'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', ':', '"',  KB_ENTER,
	KB_LSHIFT,  'Z', 'X', 'C', 'V', 'B', 'N', 'M', '<', '>', '?', KB_RSHIFT,  '/',
	KB_CTL, KB_COMMAND,  KB_ALT,  KB_FUNC, ' ',       ' ', KB_FUNC2, KB_LEFT, KB_DOWN, KB_RIGHT,  KB_DELETE
};

const kchar layout_us_func[] = {
	KB_ESC, '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '[', ']', KB_BACKSPACE,
	KB_NUMLOCK, KB_DATE, KB_ADDRESS, KB_TODO, KB_MEMO, 0, 0, 0, 0, 0, 0, '`',  KB_ENTER,
	KB_LSHIFT,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, KB_RSHIFT,  '\\',
	KB_CTL, KB_COMMAND,  KB_ALT,  KB_FUNC, ' ',       ' ', KB_FUNC2, 0, 0, 0,  KB_DELETE
};

const kchar layout_us_func2[] = {
	KB_TAB, '!', '@', '#', '$', '%', '^', '&', '*', '(', ')', '{', '}', KB_BACKSPACE,
	KB_CAPLOCK, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xa3, '~',  KB_ENTER,
	KB_LSHIFT,  0, 0, 0, 0, 0, 0, 0, 0x20ac, 0xa5, KB_PGUP, KB_RSHIFT, '|',
	KB_CTL, KB_COMMAND,  KB_ALT,  KB_FUNC, ' ',       ' ', KB_FUNC2, 0, KB_PGDN, 0,  KB_DELETE
};

// ThinkOutside French Layout
const kchar layout_fr_plain[] = {
	KB_TAB, 'a', 'z', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '^', '+', KB_BACKSPACE,
	KB_CAPLOCK, 'q', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', 'm', 0xf9,  KB_ENTER,
	KB_LSHIFT,  'w', 'x', 'c', 'v', 'b', 'n', ',', ';', ':', KB_UP, KB_RSHIFT,  '*',
	KB_CTL, KB_COMMAND,  KB_ALT,  KB_FUNC, ' ',       ' ', KB_FUNC2, KB_LEFT, KB_DOWN, KB_RIGHT,  KB_DELETE
};

const kchar layout_fr_shifted[] = {
	KB_TAB, 'A', 'Z', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', 0xa8, '=', KB_BACKSPACE,
	KB_CAPLOCK, 'Q', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', 'M', '%',  KB_ENTER,
	KB_LSHIFT,  'W', 'X', 'C', 'V', 'B', 'N', '?', '.', '/', '!', KB_RSHIFT,  '#',
	KB_CTL, KB_COMMAND,  KB_ALT,  KB_FUNC, ' ',       ' ', KB_FUNC2, KB_LEFT, KB_DOWN, KB_RIGHT,  KB_DELETE
};

const kchar layout_fr_func[] = {
	KB_ESC, '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', 0xb0, '$', KB_BACKSPACE,
	KB_NUMLOCK, KB_DATE, KB_ADDRESS, KB_TODO, KB_MEMO, 0, 0, 0, 0, 0, 0, '`',  KB_ENTER,
	KB_LSHIFT,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, KB_RSHIFT,  0xb5,
	KB_CTL, KB_COMMAND,  KB_ALT,  KB_FUNC, ' ',       ' ', KB_FUNC2, 0, 0, 0,  KB_DELETE
};

const kchar layout_fr_func2[] = {
	KB_TAB, '&', 0xe9, '"', '\'', '(', '-', 0xe8, '_', 0xe7, 0xe0, ')', '@', KB_BACKSPACE,
	KB_CAPLOCK, 0, '\\', '|', 0, '[', ']', 0, 0, 0, 0xa3, '~',  KB_ENTER,
	KB_LSHIFT,  '<', '>', 0xb2, 0xa4, '{', '}', 0, '?', 0xa5, KB_PGUP, KB_RSHIFT, 0xa7,
	KB_CTL, KB_COMMAND,  KB_ALT,  KB_FUNC, ' ',       ' ', KB_FUNC2, 0, KB_PGDN, 0,  KB_DELETE
};

// ThinkOutside DE Layout
const kchar layout_de_plain[] = {
	KB_TAB, 'q', 'w', 'e', 'r', 't', 'z', 'u', 'i', 'o', 'p', 0xfc, 0xdf, KB_BACKSPACE,
	KB_CAPLOCK, 'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', 0xf6, 0xe4,  KB_ENTER,
	KB_LSHIFT,  'y', 'x', 'c', 'v', 'b', 'n', 'm', ',', '.', KB_UP, KB_RSHIFT,  '#',
	KB_CTL, KB_COMMAND,  KB_ALT,  KB_FUNC, ' ',       ' ', KB_FUNC2, KB_LEFT, KB_DOWN, KB_RIGHT,  KB_DELETE
};

const kchar layout_de_shifted[] = {
	KB_TAB, 'Q', 'W', 'E', 'R', 'T', 'Z', 'U', 'I', 'O', 'P', 0xdc, '?', KB_BACKSPACE,
	KB_CAPLOCK, 'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', 0xd6, 0xc4,  KB_ENTER,
	KB_LSHIFT,  'Y', 'X', 'C', 'V', 'B', 'N', 'M', ';', ':', '-', KB_RSHIFT,  '\'',
	KB_CTL, KB_COMMAND,  KB_ALT,  KB_FUNC, ' ',       ' ', KB_FUNC2, KB_LEFT, KB_DOWN, KB_RIGHT,  KB_DELETE
};

const kchar layout_de_func[] = {
	KB_ESC, '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '+', '\'', KB_BACKSPACE,
	KB_NUMLOCK, KB_DATE, KB_ADDRESS, KB_TODO, KB_MEMO, 0, 0, 0, 0, 0, 0, '^',  KB_ENTER,
	KB_LSHIFT,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, KB_RSHIFT,  '_',
	KB_CTL, KB_COMMAND,  KB_ALT,  KB_FUNC, ' ',       ' ', KB_FUNC2, 0, 0, 0,  KB_DELETE
};

const kchar layout_de_func2[] = {
	KB_TAB, '!', '"', 0xa7, '$', '%', '&', '/', '(', ')', '=', '*', '`', KB_BACKSPACE,
	KB_CAPLOCK, '@', '\\', 0xb0, 0, '[', ']', 0, 0, 0, 0xa3, '~',  KB_ENTER,
	KB_LSHIFT,  '<', '>', 0, 0, '{', '}', 0xb5, 0x20ac, 0xa5, KB_PGUP, KB_RSHIFT, '|',
	KB_CTL, KB_COMMAND,  KB_ALT,  KB_FUNC, ' ',       ' ', KB_FUNC2, 0, KB_PGDN, 0,  KB_DELETE
};

// For pockettop keyboard
const kchar pockettop_lut[] = {
/* 0x00 */ 0, 'q', 0, 'z', 0, 0, 0, 'a',
/* 0x08 */ 0, 'w', 0, 'x', 0, 0, 0, 's',
/* 0x10 */ 0, 'e', 0, 'c', 0, 0, 0, 'd',
/* 0x18 */ 0, 'r', 0, 'v', 0, 0, 0, 'f',
/* 0x20 */ 0, 't', 0, 'b', 0, 0, 0, 'g',
/* 0x28 */ 0, 'y', 0, ' ', 0, 0, 0, 'h',
/* 0x30 */ 0, 'u', 'j', 'n', ' ', 0, 0, 0,
/* 0x38 */ 0, 'i', 'k', 'm', KB_FUNC, 0, 0, 0,
/* 0x40 */ KB_DATE, 'o', 'l', ',', KB_LEFT, 0, 0, 0,
/* 0x48 */ KB_ADDRESS, 'p', ';', '.', KB_DOWN, 0, 0, 0,
/* 0x50 */ KB_TODO, '-', '\'', KB_UP, KB_RIGHT, 0, 0, 0,
/* 0x58 */ KB_MEMO, KB_BACKSPACE, KB_ENTER, KB_DELETE, 0, 0, 0, 0,
/* 0x60 */ 0, 0, 0, 0, 0, KB_LSHIFT, KB_ALT, 0,
/* 0x68 */ 0, KB_TAB, 0, 0, 0, KB_CTL, KB_NUMLOCK, 0,
/* 0x70 */ 0, 0, 0, 0, 0, KB_COMMAND, KB_SHORTCUT, KB_CAPLOCK,
/* 0x78 */ 0, 0, 0, 0, 0, KB_RSHIFT, 0, 0
};

#endif