/* $Id: KeyboardDocument.cpp,v 1.2 2003/11/11 21:24:44 chrisf Exp $ */

/* Copyright (c) 2003 Chris Faherty */

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "KeyboardAppUi.h"
#include "KeyboardDocument.h"

// Standard Epoc construction sequence
CKeyboardDocument *CKeyboardDocument::NewL(CEikApplication & aApp)
{
    CKeyboardDocument *self = NewLC(aApp);
    CleanupStack::Pop(self);
    return self;
}

CKeyboardDocument *CKeyboardDocument::NewLC(CEikApplication & aApp)
{
    CKeyboardDocument *self = new(ELeave) CKeyboardDocument(aApp);
    CleanupStack::PushL(self);
    self->ConstructL();
    return self;
}

void CKeyboardDocument::ConstructL()
{
}

CKeyboardDocument::CKeyboardDocument(CEikApplication & aApp):CEikDocument(aApp)
{
}

CKeyboardDocument::~CKeyboardDocument()
{
}

CEikAppUi *CKeyboardDocument::CreateAppUiL()
{
    // Create the application user interface, and return a pointer to it
    CEikAppUi *appUi = new(ELeave) CKeyboardAppUi;
    return appUi;
}
